//--redFrik 2013

RedAlertLight {
	var <boxes;
	var <>curve= 0;
	var <>remap;
	var arrays;
	*new {|boxes|
		var map= #[
			15, 14, 13, 12, 11, 10,  9,  8,//top connectors
			 7,  6,  5,  4,  3,  2,  1,  0,
			31, 30, 29, 28, 27, 26, 25, 24,
			23, 22, 21, 20, 19, 18, 17, 16//bottom connectors
		];
		map= {|i| map+(i*32)}.dup(boxes.asArray.size).flat;
		^super.newCopyArgs(boxes.asArray).remap_(map).clearLeds;
	}
	clearLeds {
		arrays= Array.fill(boxes.size, {Array.fill(16, 0)});
		boxes.do{|box, i|
			box.sendMsg(\led, *arrays[i]);
		};
	}
	setLed {|index, value|
		var boxIndex, index2;
		value= value.lincurve(0.0, 1.0, 0, 4095, curve).asInteger;
		index= remap[index];//index remapping
		boxIndex= index.div(32);
		index2= (index%32).div(2);
		if(index%2==0, {
			arrays[boxIndex].put(index2, value.leftShift(12)+arrays[boxIndex][index2].bitAnd(4095));
		}, {
			arrays[boxIndex].put(index2, arrays[boxIndex][index2].bitAnd(16773120)+value);
		});
		boxes[boxIndex].sendMsg(\led, *arrays[boxIndex]);
	}
	setLeds {|values| //expects an array that matches in length
		values= values.lincurve(0.0, 1.0, 0, 4095, curve).asInteger;
		values.do{|value, i|
			var index= remap[i];//index remapping
			var boxIndex= index.div(32);
			var index2= (index%32).div(2);
			if(index%2==0, {
				arrays[boxIndex].put(index2, value.leftShift(12)+arrays[boxIndex][index2].bitAnd(4095));
			}, {
				arrays[boxIndex].put(index2, arrays[boxIndex][index2].bitAnd(16773120)+value);
			});
		};
		boxes.do{|box, i|
			box.sendMsg(\led, *arrays[i]);
		};
	}
	numChannels {
		^boxes.size*32;
	}
	test {
		//TODO
	}
	shutdown {
		"shutting down all boxes".warn;
		boxes.do{|x| x.sendMsg(\stop)};
	}
}
