//--redFrik 2013

RedAlertLightTest : RedAlertLight {
	var win;
	var buttons;
	*new {|boxes|
		var map= (0..31);
		map= {|i| map+(i*32)}.dup(boxes.asArray.size).flat;
		^super.newCopyArgs(boxes.asArray).remap_(map).makeWindow;
	}
	makeWindow {|position|
		{
			position= position ?? {Point(50, 400)};
			win= Window(this.class.name, Rect(position.x, position.y, 1350, 50), false);
			win.view.background= Color.black;
			win.view.decorator= FlowLayout(win.bounds);
			win.view.decorator.shift(0, 5);
			buttons= remap.collect{|x|
				Button(win, Rect(0, 0, 10, 30))
					.canFocus_(false)
					.font_(Font("Monaco", 8))
				};
			win.front;
			this.clearLeds;
			CmdPeriod.doOnce({if(win.isClosed.not, {win.close})});
		}.defer;
	}
	clearLeds {
		{
			buttons.do{|x, i|
				x.states_([[i.asString, Color.red, Color.red(0)]])
			};
			win.refresh;
		}.defer;
	}
	setLed {|index, value|
		{
			value= value.lincurve(0.0, 1.0, 0, 4095, curve).asInteger;
			buttons[index].states_([[index.asString, Color.red, Color.red(value/4095)]]);
			buttons[index].refresh;
		}.defer;
	}
	setLeds {|values| //expects an array that matches in length
		{
			values= values.lincurve(0.0, 1.0, 0, 4095, curve).asInteger;
			values.do{|value, i|
				buttons[i].states_([[i.asString, Color.red, Color.red(value/4095)]]);
			};
			win.refresh;
		}.defer;
	}
	numChannels {
		^boxes.size*32;
	}
	shutdown {
		{
			if(win.isClosed.not, {
				win.close;
			});
		}.defer;
	}
	close {
		this.shutdown;
	}
}
